//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// ChatWnd.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "ChatWnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CChatWnd dialog

IMPLEMENT_DYNAMIC(CChatWnd, CDialog)
CChatWnd::CChatWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CChatWnd::IDD, pParent)
{
}

CChatWnd::~CChatWnd()
{
}

void CChatWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHATSEL, chatselector);
	DDX_Control(pDX, IDC_LIST2, m_FriendListCtrl);
	DDX_Control(pDX, IDC_CMESSAGE, inputtext);
}

BEGIN_MESSAGE_MAP(CChatWnd, CResizableDialog)
	ON_WM_KEYDOWN()
	ON_WM_SHOWWINDOW()
	ON_MESSAGE(WM_CLOSETAB, OnCloseTab)
	ON_WM_DESTROY()
END_MESSAGE_MAP()
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CChatWnd message handlers
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CChatWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	chatselector.Init();
	m_FriendListCtrl.Init();
	
	oldMessageIcon = GetMessageStatic()->SetIcon(GetMessageIcon());
	oldFriendsIcon = GetFriendsStatic()->SetIcon(GetFriendsIcon());

	AddAnchor(IDC_CHATSEL,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(IDC_LIST2,TOP_LEFT,BOTTOM_LEFT);
	AddAnchor(IDC_FRIENDS_LBL,TOP_LEFT);
	AddAnchor(IDC_FRIENDSICON,TOP_LEFT);

	Localize();

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::StartSession(CUpDownClient* client)
{
	if (!client->GetUserName())
		return;
	g_eMuleApp.m_pdlgEmule->SetActiveDialog(this);
	chatselector.StartSession(client);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnShowWindow(BOOL bShow,UINT nStatus)
{
	if (bShow)
		chatselector.ShowChat();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CChatWnd::PreTranslateMessage(MSG* pMsg) 
{
   return CResizableDialog::PreTranslateMessage(pMsg);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::Localize()
{
	if(m_hWnd)
	{
		SetDlgItemText(IDC_FRIENDS_LBL, GetResString(IDS_CW_FRIENDS));
		SetDlgItemText(IDC_MESSAGES_LBL, GetResString(IDS_CW_MESSAGES));
		m_FriendListCtrl.Localize();
		chatselector.Localize();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CChatWnd::OnCloseTab(WPARAM wparam, LPARAM lparam)
{
	TCITEM item;
	item.mask = TCIF_PARAM;
	int i = (int)wparam;
	chatselector.GetItem(i,&item);
	
	chatselector.EndSession(((CChatItem*)item.lParam)->m_pClient);

	if(i != -1 && i > 0)
	{
		chatselector.SetCurSel(i-1);
		chatselector.ShowChat();
	}
	else if (i != -1 && i == 0)
	{
		chatselector.SetCurSel(i);
		chatselector.ShowChat();
	}

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::ScrollHistory(bool down)
{
	CString buffer;

	CChatItem* ci = chatselector.GetCurrentChatItem();
	if (ci==NULL)
		return;

	if ( (ci->m_iHistoryIndex==0 && !down) || (ci->m_iHistoryIndex==ci->m_strHistoryArray.GetCount() && down))
		return;
	
	if (down)
		++ci->m_iHistoryIndex;
	else
		--ci->m_iHistoryIndex;

	buffer= (ci->m_iHistoryIndex==ci->m_strHistoryArray.GetCount())?"":ci->m_strHistoryArray.GetAt(ci->m_iHistoryIndex);

	inputtext.SetWindowText(buffer);
	inputtext.SetSel(buffer.GetLength(),buffer.GetLength());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnDestroy()
{
	CResizableDialog::OnDestroy();
	DestroyIcon(GetMessageStatic()->SetIcon(oldMessageIcon));
	DestroyIcon(GetFriendsStatic()->SetIcon(oldFriendsIcon));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////