#pragma once
#include "titlemenu.h"

#define HTC_BOLD		0x0000001
#define HTC_ITALIC		0x0000002
#define HTC_LINK		0x0000004
#define HTC_STRIKEOUT	0x0000008
#define HTC_UNDERLINE	0x0000010

class CHTRichEditCtrl : public CRichEditCtrl
{
	DECLARE_DYNAMIC(CHTRichEditCtrl)

public:
	CHTRichEditCtrl();
	virtual ~CHTRichEditCtrl();

	void Init();
	void SetTitle(LPCTSTR pszTitle);
	void Reset();

	void AppendText(const CString& strText, COLORREF crTextColor = 0x1000000, COLORREF crBackColor = 0x1000000, DWORD dwFlags = 0);

	CString GetText() const;
	CString GetHtml();
	CString GetToolTip();

	void SetFont(CFont* pFont, bool bRedraw = true);
	void ScrollToLastLine();

	bool				m_bAutoScroll;
	bool				m_bWordWrap;

protected:
	CString				m_strTitle;
	bool				m_bNoPaint;
	bool				m_bInMenu;
	long				m_lMaxBufSize;
	HCURSOR				m_hCursor;

	void AddLine(LPCTSTR pszMsg, COLORREF crTextColor = 0x1000000, COLORREF crBackColor = 0x1000000, DWORD dwFlags = 0);
	void SaveLogToDisk();
	void SaveRtfToDisk();

	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEnLink(NMHDR *pNMHDR, LRESULT *pResult);

private:
	static DWORD __stdcall MEditStreamOutCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
	{
		CString		strThisWrite;

		strThisWrite.GetBufferSetLength(cb);

		CString		*pstrBuffer = (CString *)dwCookie;

		for (int i = 0; i < cb; i++)
		{
			strThisWrite.SetAt(i, *(pbBuff + i));
		}

		*pstrBuffer += strThisWrite;

		*pcb = strThisWrite.GetLength();
		strThisWrite.ReleaseBuffer();
		return 0;
	}
};
