//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "ircmain.h"
#include "emule.h"
#include "ED2KLink.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CIrcMain::CIrcMain(void)
{
	m_pIrcSocket = NULL;
	m_pWndIRC = 0; 
	strPreParseBuffer.Empty();
	srand((unsigned)time(NULL));
	SetVerify();
}

CIrcMain::~CIrcMain(void)
{
}

void CIrcMain::PreParseMessage(CString strBuffer)
{
	CString			strMessage;

	strPreParseBuffer += strBuffer;

	int				iIndex = strPreParseBuffer.Find(_T('\n'));

	while(iIndex != -1)
	{
		strMessage = strPreParseBuffer.Left(iIndex);
		strMessage.Remove(_T('\n'));
		strMessage.Remove(_T('\r'));
		ParseMessage(strMessage);
		strPreParseBuffer = strPreParseBuffer.Mid(iIndex + 1);
		iIndex = strPreParseBuffer.Find(_T('\n'));
	}
}

//extern void URLDecode(CString& result, const char* buff);

/*void CIrcMain::ProcessLink(const CString& ed2kLink)
{
	try {
		CString			strLink;

		strLink = URLDecode(ed2kLink);

		CED2KLink		*pLink = CED2KLink::CreateLinkFromUrl(strLink);

		_ASSERT( pLink !=0 );
		switch (pLink->GetKind())
		{
			case CED2KLink::kFile:
			{
				CED2KFileLink		*pFileLink = pLink->GetFileLink();

				_ASSERT(pFileLink !=0);
				g_eMuleApp.m_pDownloadQueue->AddFileLinkToDownload(pFileLink);
			}
			break;
			case CED2KLink::kServerList:
			{
				CED2KServerListLink		*pListLink = pLink->GetServerListLink(); 

				_ASSERT( pListLink !=0 ); 

				CString			strAddress = pListLink->GetAddress(); 

				if (!strAddress.IsEmpty())
					g_eMuleApp.m_pdlgEmule->m_wndServer.UpdateServerMetFromURL(strAddress);
			}
			break;
			case CED2KLink::kServer:
			{
				CString				strDefName;
				CED2KServerLink		*pSrvLink = pLink->GetServerLink();

				_ASSERT( pSrvLink !=0 );

				CServer				*pSrv = new CServer(pSrvLink->GetPort(),pSrvLink->GetIP());	//netwolf 07.05.03 support non-ip ed2k server link

				_ASSERT( pSrv !=0 );
				pSrvLink->GetDefaultName(strDefName);
				pSrv->SetListName(strDefName.GetBuffer());

				// Barry - Default all new irc servers to high priority
				if (g_eMuleApp.m_pGlobPrefs->GetManualHighPrio())
					pSrv->SetPreference(CServer::SERVERPRIORITY_HIGH);

				if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(pSrv, true)) 
					delete pSrv; 
				else
					AddLogLine(true, GetResString(IDS_SERVERADDED), pSrv->GetListName());
			}
			break;
			default:
				break;
		}
		delete pLink;
	} catch(...) {
		OUTPUT_DEBUG_TRACE();
		AddLogLine(true, RGB_LOG_WARNING + GetResString(IDS_LINKNOTADDED));
	}
}*/

void CIrcMain::ParseMessage(CString strRawMessage)
{
	if (strRawMessage.Left(6) == _T("PING :"))
	{
		m_pIrcSocket->SendString(_T("PONG ") + strRawMessage.Mid(6));
		m_pWndIRC->AddMessage(_T(""), _T(""), RGB(0, 147, 0), _T("PING?/PONG"));
		return;
	}
	strRawMessage.Replace(_T('%'), _T('\004'));

	CString		strSource, strSourceIP, strCommand, strTarget, strTarget2, strMessage, strTemp;
	int			iSourceIndex, iCommandIndex, iTargetIndex, iMessageIndex, iTarget2Index;

	iSourceIndex = strRawMessage.Find(_T('!'));
	iCommandIndex = strRawMessage.Find(_T(' '));
	iTargetIndex = strRawMessage.Find(_T(' '), iCommandIndex + 1);
	strCommand = strRawMessage.Mid(iCommandIndex + 1, iTargetIndex - iCommandIndex - 1);

	if (iSourceIndex < iCommandIndex && iSourceIndex > 0)
	{
		strSource = strRawMessage.Mid(1, iSourceIndex - 1);
		strSourceIP = strRawMessage.Mid(iSourceIndex + 1, iCommandIndex - iSourceIndex - 1);
		iMessageIndex = strRawMessage.Find(_T(' '), iTargetIndex + 1);
		if (iMessageIndex > iSourceIndex)
		{
			strTarget = strRawMessage.Mid(iTargetIndex + 1, iMessageIndex - iTargetIndex - 1);
			strMessage = strRawMessage.Mid(iMessageIndex);
		}
		else
			strTarget = strRawMessage.Mid(iTargetIndex + 1, strRawMessage.GetLength() - iTargetIndex - 1);
		if (strTarget[0] == _T(':'))
			strTarget = strTarget.Mid(1);
		if (strMessage[0] == _T(':'))
			strMessage = strMessage.Mid(1);
		if (strTarget.Left(2) == _T(" :"))
			strTarget = strTarget.Mid(2);
		if (strMessage.Left(2) == _T(" :"))
			strMessage = strMessage.Mid(2);
	}
	else
	{
		strSource = strRawMessage.Mid(1, iCommandIndex - 1);
		strMessage = strRawMessage.Mid(iTargetIndex + 1);
	}
	if (strCommand == _T("PRIVMSG"))
	{
		if (strTarget[0] == _T('#'))
		{
			if (strMessage[0] == _T('\001'))
			{
				strMessage = strMessage.Mid(1, strMessage.GetLength() - 2);
				if (strMessage.Left(6) == _T("ACTION"))
				{
					m_pWndIRC->AddMessage(strTarget, _T(""), RGB(156, 0, 156), _T("* %s%s"), strSource, strMessage.Mid(6));
					return;
				}
				if (strMessage.Left(7) == _T("VERSION"))
				{
					m_pWndIRC->AddMessage(strTarget, _T(""), RGB(255, 0, 0), _T("* [%s] VERSION"), strSource);
					strVersion = CString("ePlus" CURRENT_VERSION_LONG Irc_Version);
					strTemp.Format(_T("NOTICE %s :\001VERSION %s\001"), strSource, strVersion);
					m_pIrcSocket->SendString(strTemp);
					return;
				}
			}
			else
			{
                m_pWndIRC->AddMessage(strTarget, strSource, 0x1000000, strMessage);
				return;
			}
		}
		else
		{
			if (strMessage[0] == _T('\001'))
			{
				strMessage = strMessage.Mid(1, strMessage.GetLength() - 2);
				if (strMessage.Left(6) == _T("ACTION"))
				{
					m_pWndIRC->AddMessage(strSource, _T(""), RGB(0, 147, 0), _T("* %s%s"), strSource, strMessage.Mid(6));
					return;
				}
				if (strMessage.Left(7) == _T("VERSION"))
				{
					m_pWndIRC->AddMessage(strSource, _T(""), RGB(255, 0, 0), _T("* [%s] VERSION"), strSource);
					strVersion = CString("ePlus" CURRENT_VERSION_LONG Irc_Version);
					strTemp.Format(_T("NOTICE %s :\001VERSION %s\001"), strSource, strVersion);
					m_pIrcSocket->SendString(strTemp);
				}
				if (strMessage.Left(9) == _T("RQSFRIEND"))
				{
					strMessage = strMessage.Mid(9);

					int				iIndex1 = strMessage.Find(_T('|'));

					if (iIndex1 == -1 || iIndex1 == strMessage.GetLength())
						return;

					int				iIndex2 = strMessage.Find(_T('|'), iIndex1 + 1);

					if (iIndex2 == -1 || iIndex1 > iIndex2)
						return;

					CString			strVerify = strMessage.Mid(iIndex1 + 1, iIndex2 - iIndex1 - 1);
#ifdef OLD_SOCKETS_ENABLED
					CString			strIP = _T("0.0.0.0"), strPort = _T("0");
					uint32			iClientID = 0;

					if (g_eMuleApp.m_pServerConnect->IsConnected())
					{
						strIP.Format(_T("%i"), g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetIP());
						strPort.Format(_T("%i"), g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetPort());
						if (!g_eMuleApp.m_pServerConnect->IsLowID())
							iClientID = g_eMuleApp.m_pServerConnect->GetClientID();
					}
					strTemp.Format(_T("PRIVMSG %s :\001REPFRIEND ePlus%s%s|%s|%i:%i|%s:%s|%s|\001"), strSource, (CString)CURRENT_VERSION_LONG, (CString)Irc_Version, strVerify, iClientID, g_eMuleApp.m_pGlobPrefs->GetListenPort(), strIP, strPort, HashToString(g_eMuleApp.m_pGlobPrefs->GetUserHash()));
					m_pIrcSocket->SendString(strTemp);
#endif //OLD_SOCKETS_ENABLED
					strTemp.Format(_T("%s %s"), strSource, GetResString(IDS_IRC_ADDASFRIEND));
					if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreEmuleProtoInfoMessage())
						m_pWndIRC->NoticeMessage(_T("*EmuleProto*"), strTemp);
					return;
				}
				if (strMessage.Left(8) == _T("SENDLINK"))
				{
//Needs more coding (Mainly security) before releasing.

					//if (!g_eMuleApp.m_pGlobPrefs->GetIrcAcceptLinks())
					//{
						if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
							m_pWndIRC->NoticeMessage(_T("*EmuleProto*"), strSource + _T(" attempted to send you a file."));
						return;
					//}
					/*
					strMessage = strMessage.Mid(8);
					int index1, index2;
					index1 = strMessage.Find("|");
					if (index1 == -1 || index1 == strMessage.GetLength())
						return;
					index2 = strMessage.Find("|", index1+1);
					if (index2 == -1 || index1 > index2)
						return;
					CString hash = strMessage.Mid(index1+1, index2-index1-1);
					uchar userid[16];
					if (hash.GetLength()!=32 || !DecodeBase16(hash.GetBuffer(),hash.GetLength(),userid,ARRSIZE(userid)))
							return;
					CString RecieveString, build;
					if (!g_eMuleApp.friendlist->SearchFriend(userid, 0, 0))
					{
						if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
							m_pwndIRC->NoticeMessage("*EmuleProto*", _T("Someone attempt to send you a file but wasn't a friend. If you wanted to accept the file, disable From friends only in the preferences."));
						return;
					}
					RecieveString = strMessage.Mid(index2+1);
					if (!RecieveString.IsEmpty())
					{
						build.Format(GetResString(IDS_IRC_RECIEVEDLINK), strSource, RecieveString);
						if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
							m_pwndIRC->NoticeMessage("*EmuleProto*", build);
						ProcessLink(RecieveString);
					}
					return;
					*/
				}
				if (strMessage.Left(9) == _T("REPFRIEND"))
				{
					strMessage = strMessage.Mid(9);

					int				iIndex1 = strMessage.Find(_T('|'));

					if (iIndex1 == -1 || iIndex1 == strMessage.GetLength())
						return;

					int				iIndex2 = strMessage.Find(_T('|'), iIndex1 + 1);

					if (iIndex2 == -1 || iIndex1 > iIndex2)
						return;

					CString			strVerify = strMessage.Mid(iIndex1 + 1, iIndex2 - iIndex1 - 1);

					if (iVerify != _tstoi(strVerify))
						return;

					SetVerify();
					iIndex1 = strMessage.Find(_T(':'), iIndex2 + 1);
					if (iIndex1 == -1 || iIndex2 > iIndex1)
						return;

					uint32			iNewClientID = _tstoi(strMessage.Mid(iIndex2 + 1, iIndex1 - iIndex2 -1));

					iIndex2 = strMessage.Find(_T('|'), iIndex1 + 1);
					if (iIndex2 == -1 || iIndex1 >= iIndex2)
						return;

					uint32			iNewClientPort = _tstoi(strMessage.Mid(iIndex1 + 1, iIndex2 - iIndex1 -1));

					iIndex1 = strMessage.Find(_T(':'), iIndex2 + 1);
					if (iIndex1 == -1 || iIndex2 >= iIndex1)
						return;

					uint32			iNewClientServerIP = _tstoi(strMessage.Mid(iIndex2 + 1, iIndex1 - iIndex2 -1));

					iIndex2 = strMessage.Find(_T('|'), iIndex1 + 1);
					if (iIndex2 == -1 || iIndex1 >= iIndex2)
						return;

					uint32			iNewClientServerPort = _tstoi(strMessage.Mid(iIndex1 + 1, iIndex2 - iIndex1 -1));

					iIndex1 = strMessage.Find(_T('|'), iIndex2 + 1);
					if (iIndex1 == -1 || iIndex2 >= iIndex1)
						return;

					CString			strHash = strMessage.Mid(iIndex2 + 1, iIndex1 - iIndex2 -1);

					uchar			userid[16];

					if (strHash.GetLength() != 32 || !DecodeBase16(strHash.GetBuffer(), strHash.GetLength(), userid, ARRSIZE(userid)))
						return;

					g_eMuleApp.m_pFriendList->AddFriend(userid, 0, iNewClientID, iNewClientPort, 0, strSource, 1);
				}
				return;
			}
			else
			{
				m_pWndIRC->AddMessage(strSource, strSource, 0x1000000, strMessage);
				return;
			}
		}
	}
	if (strCommand == _T("JOIN"))
	{
		if (strSource == strNick)
		{
			m_pWndIRC->AddMessage(strTarget, _T(""), RGB(0, 147, 0), GetResString(IDS_IRC_HASJOINED), strSource, strTarget);
			return;
		}
		if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
			m_pWndIRC->AddMessage(strTarget, _T(""), RGB(0, 147, 0), GetResString(IDS_IRC_HASJOINED), strSource, strTarget);
		m_pWndIRC->NewNick(strTarget, strSource);
		return;
	}
	if (strCommand == _T("PART"))
	{
		if (strSource == strNick)
		{
			m_pWndIRC->RemoveChannel(strTarget);
			return;
		}
		m_pWndIRC->RemoveNick(strTarget, strSource);
		if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
		{
			CString			strMessage2 = strMessage, strLine;

			strMessage2.Trim();
			strLine.Format(GetResString(IDS_IRC_HASPARTED), strSource, strTarget, strMessage2);
			if (strMessage.IsEmpty())
				strLine.Truncate(strLine.GetLength() - 3);
			m_pWndIRC->AddMessage(strTarget, _T(""), RGB(51, 102, 255), strLine);
		}
		return;
	}

	if (strCommand == _T("TOPIC"))
	{
		m_pWndIRC->SetTitle(strTarget, strMessage);
		return;
	}

	if (strCommand == _T("QUIT"))
	{
		m_pWndIRC->DeleteNickInAll(strSource, strMessage);
		return;
	}

	if (strCommand == _T("NICK"))
	{
		if (strSource == strNick)
		{
			strNick = strTarget;
//			m_pwenIRC->SetNick(strNick);
		}
		m_pWndIRC->ChangeAllNick(strSource, strTarget);
		return;
	}

	if (strCommand == _T("KICK"))
	{
		iTarget2Index = strMessage.Find(_T(':'));
		if (iTarget2Index > 0)
		{
			strTarget2 = strMessage.Mid(1, iTarget2Index - 2);
			strMessage = strMessage.Mid(iTarget2Index + 1);
		}
		if (strTarget2 == strNick)
		{
			m_pWndIRC->RemoveChannel(strTarget);
			m_pWndIRC->AddMessage(_T(""), _T(""), RGB(252, 127, 0), GetResString(IDS_IRC_WASKICKEDBY), strTarget2, strSource, strMessage);
			return;
		}
		m_pWndIRC->RemoveNick(strTarget, strTarget2);
		if (!g_eMuleApp.m_pGlobPrefs->GetIrcIgnoreInfoMessage())
			m_pWndIRC->AddMessage(strTarget, _T(""), RGB(252, 127, 0), GetResString(IDS_IRC_WASKICKEDBY), strTarget2, strSource, strMessage);
		return;
	}
	if (strCommand == _T("MODE"))
	{
		iCommandIndex = strMessage.Find(_T(' '), 1);
		strCommand = strMessage.Mid(1, iCommandIndex - 1);
		strCommand.Replace(_T('\004'), _T('%'));
		strTarget2 = strMessage.Mid(iCommandIndex + 1);
		m_pWndIRC->ParseChangeMode(strTarget, strSource, strCommand, strTarget2);
		return;
	}
	if (strCommand == _T("NOTICE"))
	{
		m_pWndIRC->NoticeMessage(strSource, strMessage);
		return;
	}
	if (strCommand == _T("001"))
	{
		m_pWndIRC->SetLoggedIn(true);
		if (g_eMuleApp.m_pGlobPrefs->GetIRCListOnConnect())
			m_pIrcSocket->SendString(_T("list"));
		ParsePerform();
	}

	if (strCommand == _T("321"))
	{
		m_pWndIRC->ResetServerChannelList();
		return;
	}

	if (strCommand == _T("322"))
	{
		CString			strChanName, strChanNum, strChanDesc;
		int				iChanNameIndex, iChanNumIndex, iChanDescIndex;

		iChanNameIndex = strMessage.Find(_T(' '));
		iChanNumIndex = strMessage.Find(_T(' '), iChanNameIndex + 1);
		iChanDescIndex = strMessage.Find(_T(' '), iChanNumIndex + 1);
		strChanName = strMessage.Mid(iChanNameIndex + 1, iChanNumIndex - iChanNameIndex - 1);
		strChanNum = strMessage.Mid(iChanNumIndex + 1, iChanDescIndex - iChanNumIndex - 1);
		if (iChanDescIndex > 0)
		{
			iChanDescIndex = strMessage.Find(_T(' '), iChanDescIndex + 1);
			if (iChanDescIndex > 0)
				strChanDesc = strMessage.Mid(iChanDescIndex);
		}
		m_pWndIRC->AddChannelToList(strChanName, strChanNum, strChanDesc);
		return;
	}
	if (strCommand == _T("332"))
	{
		strTarget2 = strMessage.Mid(strMessage.Find(_T('#')), strMessage.Find(_T(':')) - strMessage.Find(_T('#')) -1);
		strMessage = strMessage.Mid(strMessage.Find(_T(':')) + 1);
		m_pWndIRC->SetTitle(strTarget2, strMessage);
		m_pWndIRC->AddMessage(strTarget2, _T(""), RGB(0, 147, 0), _T("* Channel Title: %s"), strMessage);
		return;
	}
	if (strCommand == _T("353"))
	{
		int				iGetNickChannelIndex, iGetNickIndex, iCount = 0;
		CString			strGetNickChannel, strGetNick;

		VERIFY ( (iGetNickChannelIndex = strRawMessage.Find(_T(' '), iTargetIndex + 1)) != (-1) );
		iGetNickChannelIndex = strRawMessage.Find(_T(' '), iTargetIndex + 1);
		iGetNickIndex = strRawMessage.Find(_T(' '), iGetNickChannelIndex + 3);
		strGetNickChannel = strRawMessage.Mid(iGetNickChannelIndex + 2, iGetNickIndex - iGetNickChannelIndex - 2);
		iGetNickChannelIndex = strRawMessage.Find(_T(':'), iGetNickChannelIndex);
		iGetNickIndex = strRawMessage.Find(_T(' '), iGetNickChannelIndex);
		strRawMessage.Replace(_T('\004'), _T('%'));
		
		while(iGetNickIndex > 0)
		{
			iCount++;
			strGetNick = strRawMessage.Mid(iGetNickChannelIndex + 1, iGetNickIndex - iGetNickChannelIndex - 1);
			iGetNickChannelIndex = iGetNickIndex;
			m_pWndIRC->NewNick(strGetNickChannel, strGetNick);
			iGetNickIndex = strRawMessage.Find(_T(' '), iGetNickChannelIndex + 1);
		}
		return;
	}
	if (strCommand == _T("433"))
	{
		if (!m_pWndIRC->GetLoggedIn())
			Disconnect();
		m_pWndIRC->AddMessage(_T(""), _T(""), RGB(252, 127, 0), GetResString(IDS_IRC_NICKUSED));
		return;
	}
	m_pWndIRC->AddMessage(_T(""), _T(""), 0x1000000, strMessage);
}

void CIrcMain::SendLogin()
{
	m_pIrcSocket->SendString(strUser);
	m_pIrcSocket->SendString(_T("NICK ") + strNick);
}

void CIrcMain::ParsePerform()
{
	CString			strRawPerform;

//	if (g_eMuleApp.m_pGlobPrefs->GetIrcHelpChannel())
//		strRawPerform = "/" + GetResString(IDS_IRC_HELPCHANNELPERFORM) + "|";
	if (g_eMuleApp.m_pGlobPrefs->GetIrcUsePerform())
		strRawPerform += g_eMuleApp.m_pGlobPrefs->GetIrcPerformString();

	if (strRawPerform.IsEmpty())
		return;

	int				iIndex = 0;
	CString			strNextPerform;

	while (strRawPerform.Find(_T('|')) != -1)
	{
		iIndex = strRawPerform.Find(_T('|'));
		strNextPerform = strRawPerform.Left(iIndex);
		strNextPerform.TrimLeft(_T(' '));
		if (strNextPerform[0] == _T('/'))
			strNextPerform = strNextPerform.Mid(1);
		if (strNextPerform.Left(3) == _T("msg"))
			strNextPerform = _T("PRIVMSG") + strNextPerform.Mid(3);
		if ((strNextPerform.Left(16)).CompareNoCase(_T("PRIVMSG nickserv")) == 0)
			strNextPerform = _T("ns") + strNextPerform.Mid(16);
		if ((strNextPerform.Left(16)).CompareNoCase(_T("PRIVMSG chanserv")) == 0)
			strNextPerform = _T("cs") + strNextPerform.Mid(16);
		m_pIrcSocket->SendString(strNextPerform);
		strRawPerform = strRawPerform.Mid(iIndex + 1);
	}
	if (!strRawPerform.IsEmpty())
	{
		strRawPerform.TrimLeft(_T(' '));
		if (strRawPerform[0] == _T('/'))
			strRawPerform = strRawPerform.Mid(1);
		if (strRawPerform.Left(3) == _T("msg"))
			strRawPerform = _T("PRIVMSG") + strRawPerform.Mid(3);
		if ((strRawPerform.Left(16)).CompareNoCase(_T("PRIVMSG nickserv")) == 0)
			strRawPerform = _T("ns") + strRawPerform.Mid(16);
		if ((strRawPerform.Left(16)).CompareNoCase(_T("PRIVMSG chanserv")) == 0)
			strRawPerform = _T("cs") + strRawPerform.Mid(16);
		if (!strRawPerform.IsEmpty())
			m_pIrcSocket->SendString(strRawPerform);
	}
}

void CIrcMain::Connect()
{
	CString			iIdent;
	uint32			iIdent_int = 0;

	for (int i = 0; i < 16; i++)
	{
		iIdent_int += g_eMuleApp.m_pGlobPrefs->GetUserHash()[i] * g_eMuleApp.m_pGlobPrefs->GetUserHash()[15 - i];
	}
	iIdent.Format(_T("e%u"), iIdent_int);
	if (iIdent.GetLength() > 8)
		iIdent.Truncate(8);
	m_pIrcSocket = new CIrcSocket(this);
	strNick = g_eMuleApp.m_pGlobPrefs->GetIRCNick();
	strNick.Remove(_T('.'));
	strNick.Remove(_T(' '));
	strNick.Remove(_T(':'));
	strNick.Remove(_T('/'));
	strNick.Remove(_T('@'));
	if (strNick.GetLength() > 20)
		strNick.Truncate(20);
	strVersion = _T("ePlus") CURRENT_VERSION_LONG Irc_Version;
	strUser = _T("USER ") + iIdent + _T(" 8 * :") + strVersion;
	m_pIrcSocket->Create();
	m_pIrcSocket->Connect();
}

void CIrcMain::Disconnect(bool bIsShuttingDown)
{
	m_pIrcSocket->Close();
	if (m_pIrcSocket != NULL) 
		delete m_pIrcSocket;
	m_pIrcSocket = NULL;
	if (!bIsShuttingDown)
		m_pWndIRC->SetConnectStatus(false);
}

void CIrcMain::SetConnectStatus(bool bConnected)
{
	m_pWndIRC->SetConnectStatus(bConnected);
}

int CIrcMain::SendString(CString strSend)
{
	return m_pIrcSocket->SendString(strSend);
}