#include "StdAfx.h"
#ifndef NEW_SOCKETS_ENGINE
#include "emule.h"
#endif //NEW_SOCKETS_ENGINE
#include "loggable.h"

void CLoggable::AddLogLine(bool addtostatusbar, UINT nID, ...)
{

	va_list argptr;
	va_start(argptr, nID);
	AddLogText(false, addtostatusbar, GetResString(nID), argptr);
	va_end(argptr);
}

void CLoggable::AddLogLine(bool addtostatusbar, LPCTSTR line, ...)
{

	ASSERT(line != NULL);

	va_list argptr;
	va_start(argptr, line);
	AddLogText(false, addtostatusbar, line, argptr);
	va_end(argptr);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CLoggable::AddDebugLogLine(bool addtostatusbar, UINT nID, ...)
{

	va_list argptr;
	va_start(argptr, nID);
	AddLogText(true, addtostatusbar, GetResString(nID), argptr);
	va_end(argptr);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CLoggable::AddDebugLogLine(bool addtostatusbar, LPCTSTR line, ...)
{

	ASSERT(line != NULL);

	va_list argptr;
	va_start(argptr, line);
	AddLogText(true, addtostatusbar, line, argptr);
	va_end(argptr);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CLoggable::AddLogText(bool debug, bool addtostatusbar, LPCTSTR line, va_list argptr)
{
	ASSERT(line != NULL);

	EMULE_TRY

#ifndef NEW_SOCKETS_ENGINE
	if (debug && !g_eMuleApp.m_pGlobPrefs->GetVerbose())
		return ;
#endif //NEW_SOCKETS_ENGINE

	CString sBuffer;

	sBuffer.FormatV(line, argptr);

#ifndef NEW_SOCKETS_ENGINE
#ifdef _DEBUG
	//SyruS (0.29c) view the log messages while shutting down at least in the debugger
	if (g_eMuleApp.m_app_state != g_eMuleApp.APP_STATE_RUNNING)
		TRACE("App Log: %s\n", sBuffer);

#endif

	if (g_eMuleApp.m_pdlgEmule)
		g_eMuleApp.m_pdlgEmule->AddLogText(addtostatusbar, sBuffer, debug);	//Cax2 - debug log and normal log handled by the same subroutine now
#endif //NEW_SOCKETS_ENGINE

#ifdef _DEBUG

	if (debug)
		::OutputDebugString(sBuffer + _T("\n"));

#endif

	EMULE_CATCH2
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CLoggable::PacketToDebugLogLine(LPCTSTR info, char * packet, uint32 size, byte opcode) const
{
#ifndef NEW_SOCKETS_ENGINE

	CString strBuffer;
	uint32 dwMaxSize = 100;

	strBuffer.Format(_T("%s: %02x, size=%u, data=["), info, opcode, size);
	for (uint32 i = 0; (i < size && i < dwMaxSize); i++)
	{
		strBuffer.AppendFormat(_T("%02x "), (byte)packet[i]);
	}

	strBuffer += ((size < dwMaxSize) ? _T("]") : _T("..]"));
	g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, strBuffer);
#endif //NEW_SOCKETS_ENGINE
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CLoggable::TagToDebugLogLine(LPCTSTR info, LPCTSTR tag, uint32 size, byte opcode) const
{
#ifndef NEW_SOCKETS_ENGINE
	CString strBuffer;
	uint32 dwMaxSize = 100;
	
	strBuffer.Format(_T("%s: %02x, size=%u, data=["), info, opcode, size);
	for (uint32 i = 0; (i < size && i < dwMaxSize); i++)
	{
		strBuffer.AppendFormat(_T("%02x "), (byte)tag[i]);
	}

	strBuffer += ((size < dwMaxSize) ? _T("]") : _T("..]"));
	g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, strBuffer);
#endif //NEW_SOCKETS_ENGINE
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
