#pragma once

// CPPgFiles dialog

#include "Preferences.h"
#include "afxcmn.h"
#include "afxwin.h"

class CPPgFiles : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgFiles)

public:
	CPPgFiles();
	virtual ~CPPgFiles();

	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_FILES };
protected:
	CPreferences *m_pPrefs;	

	//{{AFX_MSG(CSpinToolBar)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
private:
	void LoadSettings(void);
public:
	virtual BOOL OnApply();
	afx_msg void OnSettingsChange()				{ SetModified(); }
	afx_msg void OnBnClickedDAP();
	afx_msg void OnBnClickedStartPaused();
	void Localize(void);
protected:
	BOOL dapEnable;
	BOOL uap;
	BOOL startPaused;
	BOOL startPausedOnComplete;
	BOOL resumeOtherCat;
	CString apHigh;
	CString apLow;
	int seeShare;
	int hashPriority;
	int fileBufferSize;
	int m_iCopyBufferSz;
private:
	CSliderCtrl fileBufferSizeSlider;
	CSliderCtrl m_fileCopySizeSlider;
	CString fileBufferSizeDesc;
	CEdit apHighEdit;
	CEdit apLowEdit;
	CString seeMyShareDesc;
	CButton seeEverybodyRadio;
	CButton seeFriendRadio;
	CButton seeNooneRadio;
	CButton hashStandardRadio;
	CButton hashLowerRadio;
	CButton hashIdleRadio;
	CString apGrpDesc;
	CString apHighDesc;
	CString apLowDesc;
	CButton dapEnableCheck;
	CButton uapCheck;
	CButton startPausedCheck;
	CButton startPausedOnCompleteCheck;
	CButton resumeOtherCatCheck;
	CString apSources1Desc;
	CString apSources2Desc;
	CString hashingFrmDesc;
	CString m_strCopyBufferDesc;
};
