//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//	ListenSocket.cpp : implementation file

#include "stdafx.h"
#include "emule.h"
#include "ClientList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	VerifyUpload() returns true if the spec'd client is downloading and has a data rate over 1k/sec or has
//		transferred over 400k. METHOD IS NOT USED.
bool CClientList::VerifyUpload(uint32 dwClientIP, uint16 nPort)
{
	CUpDownClient		*pClient = FindClientByIP(dwClientIP, nPort);

	if ( pClient != NULL
	  && ( (pClient->GetDownloadState() == DS_DOWNLOADING && pClient->GetDataRate() > 1000)
	    || (pClient->GetTransferredDown() > 400000) ) )
	{
		return true;
	}

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient *CClientList::VUGetRandomClient()
{
	CTypedPtrList<CPtrList, CUpDownClient*>		clientList;
	CUpDownClient							   *pClient;

	for (POSITION pos = m_clientList.GetHeadPosition(); pos != NULL; )
	{
		pClient = m_clientList.GetNext(pos);

#ifdef OLD_SOCKETS_ENABLED
		if ( pClient->m_pRequestSocket != NULL && pClient->m_pRequestSocket->IsConnected()
		  && pClient->GetMuleVersion() >= 0x20 && (pClient->GetTransferredUp() > 400000) )
		{
			clientList.AddTail(pClient);
		}
#endif //OLD_SOCKETS_ENABLED
	}
	if (clientList.IsEmpty())
		return NULL;

	uint16		nRandomIndex = static_cast<uint16>(ROUND((static_cast<double>(rand()) / RAND_MAX) * (clientList.GetCount() - 1)));

	ASSERT (clientList.FindIndex(nRandomIndex) != NULL);

	return clientList.GetAt(clientList.FindIndex(nRandomIndex));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
